import type { D3DragEvent, SubjectPosition } from 'd3-drag'
import type { Ref } from 'vue'
import type { MaybeRef } from '@vueuse/core'
export declare type UseDragEvent = D3DragEvent<HTMLDivElement, null, SubjectPosition>
export declare interface UseDragData {
  dx: number
  dy: number
}
declare interface UseDragParams {
  onStart: (event: UseDragEvent) => void
  onDrag: (event: UseDragEvent, data: UseDragData) => void
  onStop: (event: UseDragEvent) => void
  el: Ref<Element>
  disabled?: MaybeRef<boolean>
  noDragClassName?: MaybeRef<string>
  handleSelector?: string
  id?: string
}
declare function useDrag(params: UseDragParams): import('vue').WatchStopHandle
export default useDrag
